#pragma once
#include <glew.h>
#include <glut.h>
#include "vector3.h"
#include "material.h"
using namespace std;

namespace OpenglTest
{
	class geometry
	{
	public:
		bool bCreate = false;
		int indexCount = 0;
		GLuint vboId;
		GLuint eboId;
		vector3 position = vector3(0.f, 0.f, 0.f);
		vector3 rot = vector3(0.f, 0.f, 0.f);
		float angle = 0;
		material* mat = new material();
	public:
		virtual void init(){};
		virtual void draw(){};

		inline void getMaterial(float*& mat)
		{
			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
			glLoadIdentity();
			glTranslatef(position.x, position.y, position.z);
			glRotatef(angle, rot.x, rot.y, rot.z);
			glGetFloatv(GL_MODELVIEW_MATRIX, mat);
			glPopMatrix();
		}
	private:

	};
}