#include "loadtexture.h"

namespace OpenglTest
{
	imageInfo imageInfo::rgbTorgba(unsigned char aplph)
	{
		if (this->format == GL_RGBA)
			return *this;
		imageInfo newInfo;
		newInfo.width = width;
		newInfo.height = height;
		newInfo.format = GL_RGBA;
		newInfo.pixels.resize(width*height * 4);
		int index = 0;
		int newIndex = 0;
		for (size_t i = 0; i < width*height; i++)
		{
			newInfo.pixels[newIndex++] = (pixels[index++]);
			newInfo.pixels[newIndex++] = (pixels[index++]);
			newInfo.pixels[newIndex++] = (pixels[index++]);
			newInfo.pixels[newIndex++] = (aplph);
		}
		return newInfo;
	}


	loadtexture::loadtexture()
	{
	}


	loadtexture::~loadtexture()
	{
	}

	void loadtexture::loadBmp(string filename, imageInfo& info)
	{
		std::fstream hFile(filename, std::ios::in | std::ios::binary);
		if (!hFile.is_open()) 
			throw std::invalid_argument("Error: File Not Found.");

		hFile.seekg(0, std::ios::end);
		int Length = hFile.tellg();
		hFile.seekg(0, std::ios::beg);
		std::vector<uint8_t> fileInfo(Length);
		hFile.read(reinterpret_cast<char*>(fileInfo.data()), 54);

		if (fileInfo[0] != 'B' && fileInfo[1] != 'M')
		{
			hFile.close();
			throw std::invalid_argument("Error: Invalid File Format. Bitmap Required.");
		}

		if (fileInfo[28] != 24 && fileInfo[28] != 32)
		{
			hFile.close();
			throw std::invalid_argument("Error: Invalid File Format. 24 or 32 bit Image Required.");
		}

		auto bitsPerPixel = fileInfo[28];
		if (bitsPerPixel == 32)
			info.format = GL_RGBA;
		info.width = fileInfo[18] + (fileInfo[19] << 8);
		info.height = fileInfo[22] + (fileInfo[23] << 8);
		uint32_t bixelsOffset = fileInfo[10] + (fileInfo[11] << 8);
		uint32_t size = ((info.width * bitsPerPixel + 31) / 32) * 4 * info.height;
		info.pixels.resize(size);

		hFile.seekg(bixelsOffset, std::ios::beg);
		hFile.read(reinterpret_cast<char*>(info.pixels.data()), size);
		hFile.close();
	}

	GLuint loadtexture::textureMap(string fileName)
	{
		imageInfo info;
		loadBmp(fileName, info);

		GLuint texture;
		glGenTextures(1, &texture);//䵽IDֵΪá
		glBindTexture(GL_TEXTURE_2D, texture);//GL_TEXTTURE_2DĲӦtextures
		gluBuild2DMipmaps(GL_TEXTURE_2D, 0, info.width, info.height,
			GL_RGB, GL_UNSIGNED_BYTE, info.pixels.data());

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

		glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		glBindTexture(GL_TEXTURE_2D, 0);
		return texture;
	}


}
