#include "material.h"

namespace OpenglTest
{
	const GLfloat material::no_mat[4] = { 0.0, 0.0, 0.0, 1.0 };
	const GLfloat material::white[4] = { 1.0, 1.0, 1.0, 1.0 };
	const GLfloat material::red[4] = { 1.0, 0.0, 0.0, 1.0 };
	const GLfloat material::green[4] = { 0.0, 1.0, 0.0, 1.0 };
	const GLfloat material::blue[4] = { 0.0, 0.0, 1.0, 1.0 };
	const GLfloat material::gray[4] = { 0.1, 0.1, 0.1, 1.0 };
	material::material()
	{
		material::setValue(ambinet, material::white);
		material::setValue(diffuse, material::white);
		material::setValue(specular, material::no_mat);
		material::setValue(emission, material::no_mat);
		shininess = 100.0f;
	}

	material::~material()
	{
	}

	void material::draw()
	{
		GLenum eface = GL_FRONT;
		if (face == GL_FRONT_AND_BACK)
			eface = GL_FRONT_AND_BACK;
		glMaterialfv(eface, GL_AMBIENT, ambinet);
		glMaterialfv(eface, GL_DIFFUSE, diffuse);
		glMaterialfv(eface, GL_SPECULAR, specular);
		glMaterialfv(eface, GL_EMISSION, emission);
		glMaterialf(eface, GL_SHININESS, shininess);
	}

	void material::setValue(GLfloat source[4], const GLfloat dest[4])
	{
		source[0] = dest[0];
		source[1] = dest[1];
		source[2] = dest[2];
		source[3] = dest[3];
	}
}
