#include "glshow.h"
namespace OpenglTest
{
	class fixshadowmapping : public glshow
	{
	public:
		fixshadowmapping()
		{
			sphLight = new sphere(16, 16, 0.1f);
			mplane = new plane(201, 201, 0.1, 0.1, 0.f);
			msphere = new sphere(16, 16, 0.8f);
			shadowWidth = 1024;
			shadowHeight = 1024;
			lightProjection = new float[16];
			lightModelview = new float[16];
		}

		void createScene()
		{
			glshow::createScene();

			glEnable(GL_LIGHTING);
			glEnable(GL_LIGHT0);
			glEnable(GL_DEPTH_TEST);
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);		

			//glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
			//glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, material::gray);
			// lighting, light0
			float white[] = { 0.9, 0.9, 0.9, 1.0 };
			glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
			glLightfv(GL_LIGHT0, GL_SPECULAR, white);
			glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material::gray);
			//˫չر,ɫɫһ,ֿ
			glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, false);
			//ƹ
			sphLight->mat->face = GL_FRONT_AND_BACK;
			material::setValue(sphLight->mat->emission, white);
			//
			mplane->mat->face = GL_FRONT_AND_BACK;
			//СʱҪӰ
			material::setValue(mplane->mat->ambinet, material::red);
			//մʱҪӰ
			material::setValue(mplane->mat->diffuse, material::white);
			mplane->position = vector3(0.f, -1.f, 0.f);
			//
			msphere->mat->face = GL_FRONT_AND_BACK;
			material::setValue(msphere->mat->ambinet, material::green);
			material::setValue(msphere->mat->diffuse, material::red);
			material::setValue(msphere->mat->specular, material::white);
			msphere->position = vector3(-2.f, 0.f, 0.f);

			//Ҫõһģ϶,Ҫö
			glActiveTexture(GL_TEXTURE0);
			glEnable(GL_TEXTURE_2D);
			glGenTextures(1, &planeTexture);
			glBindTexture(GL_TEXTURE_2D, planeTexture);
			imageInfo info = {};
			loadtexture::loadBmp("Grid.bmp", info);
			//info = info.rgbTorgba(255);
			//GL_DECAL ֻɫɫ
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);//GL_REPLACE,GL_MODULATE,GL_DECAL,GL_BLEND
			// 곬[0,1]ʱδ
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			// 괦ʽԲֵ
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
			//ʹԼ
			glDisable(GL_TEXTURE_GEN_S);
			glDisable(GL_TEXTURE_GEN_T);
			glDisable(GL_TEXTURE_GEN_R);
			glDisable(GL_TEXTURE_GEN_Q);
			glTexImage2D(GL_TEXTURE_2D, 0, info.format, info.width, info.height,
				0, info.format, GL_UNSIGNED_BYTE, info.pixels.data());
			glBindTexture(GL_TEXTURE_2D, 0);

			glActiveTexture(GL_TEXTURE1);
			glEnable(GL_TEXTURE_2D);
			glGenTextures(1, &shadowTexture);
			glBindTexture(GL_TEXTURE_2D, shadowTexture);
			// ͹ռ
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			//GL_LUMINANCE ֵ滻RGB,GL_INTENSITY滻RGBAĸ.(ֵֻһ)
			//˵,Ƕα,GL_ALPHA,滻ĸ.
			//glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_LUMINANCE);// GL_LUMINANCE);
			// This is to allow usage of shadow2DProj function in the shader
			//ֵ,꾭תɶӦ. RȽ
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);//GL_NONE GL_COMPARE_R_TO_TEXTURE
			//ȽϷ,ڻ1,0
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_LEQUAL);//GL_GEQUAL,GL_LEQUAL
			//ʹAPIԶɵ
			glEnable(GL_TEXTURE_GEN_S);
			glEnable(GL_TEXTURE_GEN_T);
			glEnable(GL_TEXTURE_GEN_R);
			glEnable(GL_TEXTURE_GEN_Q);
			glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
			glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
			glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
			glTexGeni(GL_Q, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, shadowWidth, shadowHeight,
				0, GL_DEPTH_COMPONENT, GL_FLOAT, 0);
			//FBO 建shadowTexture
			glGenFramebuffers(1, &frameBuffer);
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, frameBuffer);
			glFramebufferTexture2D(GL_DRAW_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, shadowTexture, 0);
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, 0);
			glBindTexture(GL_TEXTURE_2D, 0);
		}

		void draw()
		{
			//ƹλ
			auto timeLenght = clock();
			vector3 lightpos;
			lightpos.x = cos(timeLenght / 1000.0f) * 2.0f;
			lightpos.y = 5.0f;
			lightpos.z = sin(timeLenght / 1000.0f) * 4.0f + 6;

			//дȵFBO,ԵƹΪӽ
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, frameBuffer);
			//ɫҪ
			glColorMask(false, false, false, false);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			glViewport(0, 0, shadowWidth, shadowHeight);
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			gluPerspective(90.0f, shadowWidth / shadowHeight, 1.0f, 1000.0f);
			glGetFloatv(GL_PROJECTION_MATRIX, lightProjection);
			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
			gluLookAt(lightpos.x, lightpos.y, lightpos.z, 0.f, 0.f, 0.f, 0.f, 1.0f, 0.f);
			glGetFloatv(GL_MODELVIEW_MATRIX, lightModelview);
			this->drawModel(true);
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, 0);

			//任 Զתɶ
			float tempMat[16];
			glPushMatrix();
			glLoadIdentity();
			glTranslatef(0.5f, 0.5f, 0.5f);
			glScalef(0.5f, 0.5f, 0.5f);
			// Proj * Model תռ
			glMultMatrixf(lightProjection);
			glMultMatrixf(lightModelview);
			glGetFloatv(GL_MODELVIEW_MATRIX, tempMat);
			glLoadTransposeMatrixf(tempMat);
			glGetFloatv(GL_MODELVIEW_MATRIX, tempMat);
			glPopMatrix();

			//
			glColorMask(true, true, true, true);
			glViewport(0, 0, widht, height);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			gluPerspective(45.0f, (GLfloat)this->widht / (GLfloat)this->height, 0.1f, 100.0f);
			//ͼ
			this->mcamera->lookat();
			//һԴ.
			float pos[4] = { lightpos.x, lightpos.y, lightpos.z, 1.0 };
			glLightfv(GL_LIGHT0, GL_POSITION, pos);
			//,ģͱ
			glActiveTexture(GL_TEXTURE0);			
			glBindTexture(GL_TEXTURE_2D, planeTexture);
			//,APIԶɵ
			glActiveTexture(GL_TEXTURE1);			
			glBindTexture(GL_TEXTURE_2D, shadowTexture);
			glTexGenfv(GL_S, GL_OBJECT_PLANE, &tempMat[0]);
			glTexGenfv(GL_T, GL_OBJECT_PLANE, &tempMat[4]);
			glTexGenfv(GL_R, GL_OBJECT_PLANE, &tempMat[8]);
			glTexGenfv(GL_Q, GL_OBJECT_PLANE, &tempMat[12]);
			mplane->draw();
			//ǵĹص,ȻӰģ
			glActiveTexture(GL_TEXTURE0);			
			glBindTexture(GL_TEXTURE_2D, 0);
			glActiveTexture(GL_TEXTURE1);			
			glBindTexture(GL_TEXTURE_2D, 0);
			//,,
			sphLight->position.x = lightpos.x;
			sphLight->position.y = lightpos.y;
			sphLight->position.z = lightpos.z;
			this->drawModel(false);
			glutSwapBuffers();
		}

		void drawModel(bool shadow)
		{
			sphLight->draw();
			msphere->draw();

			glPushMatrix();
			glTranslatef(0, 0.3f, 0);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::blue);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::green);
			//glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material::white);
			glutSolidTeapot(1);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(-3, 0, 1);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::green);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::white);
			glutSolidCube(1);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(3, 0, -1);
			glRotatef(90, -1, 0, 0);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::red);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::white);
			glutSolidCone(1, 2, 20, 20);
			glPopMatrix();
		}

		~fixshadowmapping()
		{
			delete sphLight;
			delete mplane;
			delete msphere;
			if (lightModelview != nullptr)
				delete lightModelview;
			if (lightProjection != nullptr)
				delete lightProjection;
		}

	private:
		sphere* sphLight = nullptr;
		plane* mplane = nullptr;
		sphere* msphere = nullptr;

		int shadowWidth;
		int shadowHeight;
		float* lightProjection = nullptr;
		float* lightModelview = nullptr;
		GLuint sphereTexture = 0;
		GLuint shadowTexture = 0;
		GLuint planeTexture = 0;
		GLuint frameBuffer = 0;
	};
}
//glBindTexture(GL_TEXTURE_2D, shadowTexture);
//vector<float> data;
//data.resize(shadowWidth*shadowHeight);//GL_DEPTH_COMPONENT
//glGetTexImage(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, GL_FLOAT, data.data()); // ȡ
//int index = 0;
//for_each(data.begin(), data.end(), [&index](float x){
//	if (x > 0 && x < 0.9f)
//	{
//		//cout << "index:" << index << " vlaue:" << x << endl;					
//	}
//	index++;
//});