#include "glshow.h"
#include "glslprogram.h"
#include "Matrices.h"

namespace OpenglTest
{
	class programshadowmapping : public glshow
	{
	public:
		programshadowmapping()
		{
			sphLight = new sphere(16, 16, 0.1f);
			mplane = new plane(201, 201, 0.1, 0.1, 0.f);
			msphere = new sphere(16, 16, 0.8f);
			shadowWidth = 1024;
			shadowHeight = 1024;
		}

		void createScene()
		{
			glshow::createScene();

			glEnable(GL_LIGHTING);
			glEnable(GL_LIGHT0);
			glEnable(GL_DEPTH_TEST);
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			//ʹԼ
			glDisable(GL_TEXTURE_GEN_S);
			glDisable(GL_TEXTURE_GEN_T);
			glDisable(GL_TEXTURE_GEN_R);
			glDisable(GL_TEXTURE_GEN_Q);

			float white[] = { 0.9, 0.9, 0.9, 1.0 };
			glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
			glLightfv(GL_LIGHT0, GL_SPECULAR, white);
			glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material::gray);
			//˫չر,ɫɫһ,ֿ
			glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, true);
			//ƹ
			sphLight->mat->face = GL_FRONT_AND_BACK;
			material::setValue(sphLight->mat->emission, white);
			//
			mplane->mat->face = GL_FRONT_AND_BACK;
			//СʱҪӰ
			material::setValue(mplane->mat->ambinet, material::gray);
			//մʱҪӰ
			material::setValue(mplane->mat->diffuse, material::white);
			material::setValue(mplane->mat->specular, material::red);
			mplane->position = vector3(0.f, -1.f, 0.f);
			//
			msphere->mat->face = GL_FRONT_AND_BACK;
			material::setValue(msphere->mat->ambinet, material::green);
			material::setValue(msphere->mat->diffuse, material::red);
			material::setValue(msphere->mat->specular, material::white);
			msphere->position = vector3(-2.f, 0.f, 0.f);

			//Ҫõһģ϶,Ҫö
			glActiveTexture(GL_TEXTURE0);
			glGenTextures(1, &planeTexture);
			glBindTexture(GL_TEXTURE_2D, planeTexture);
			imageInfo info = {};
			loadtexture::loadBmp("Grid.bmp", info);
			//GL_DECAL ֻɫɫ
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);//GL_REPLACE,GL_MODULATE,GL_DECAL,GL_BLEND
			// 곬[0,1]ʱδ
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			// 괦ʽԲֵ
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
			glTexImage2D(GL_TEXTURE_2D, 0, info.format, info.width, info.height,
				0, info.format, GL_UNSIGNED_BYTE, info.pixels.data());
			glBindTexture(GL_TEXTURE_2D, 0);

			glActiveTexture(GL_TEXTURE1);
			glGenTextures(1, &shadowTexture);
			glBindTexture(GL_TEXTURE_2D, shadowTexture);
			// ͹ռ
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			//GL_LUMINANCE ֵ滻RGB,GL_INTENSITY滻RGBAĸ.(ֵֻһ)
			//˵,Ƕα,GL_ALPHA,滻ĸ.
			glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_ALPHA);// GL_LUMINANCE);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, shadowWidth, shadowHeight,
				0, GL_DEPTH_COMPONENT, GL_FLOAT, 0);
			glBindTexture(GL_TEXTURE_2D, 0);
			//FBO 建shadowTexture
			glGenFramebuffers(1, &frameBuffer);
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, frameBuffer);
			glFramebufferTexture2D(GL_DRAW_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, shadowTexture, 0);
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, 0);

			//glsl
			program.initShader("sm_vs.glsl", "sm_fs.glsl");
			program.linkShader();
		}

		void draw()
		{
			//ƹλ
			auto timeLenght = clock();
			vector3 lightpos;
			lightpos.x = cos(timeLenght / 1000.0f) * 2.0f;
			lightpos.y = 5.0f;
			lightpos.z = sin(timeLenght / 1000.0f) * 4.0f;

			////дȵFBO,ԵƹΪӽ
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, frameBuffer);
			//ɫҪ
			glColorMask(false, false, false, false);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			glViewport(0, 0, shadowWidth, shadowHeight);
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			gluPerspective(90.0f, shadowWidth / shadowHeight, 1.0f, 1000.0f);
			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
			gluLookAt(lightpos.x, lightpos.y, lightpos.z, 0.f, 0.f, 0.f, 0.f, 1.0f, 0.f);
			this->drawModel(true);
			glBindFramebuffer(GL_DRAW_FRAMEBUFFER, 0);

			//
			glColorMask(true, true, true, true);
			glViewport(0, 0, widht, height);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			gluPerspective(45.0f, (GLfloat)this->widht / (GLfloat)this->height, 0.1f, 100.0f);
			//ͼ
			this->mcamera->lookat();

			//һԴ.
			float pos[4] = { lightpos.x, lightpos.y, lightpos.z, 1.0 };
			glLightfv(GL_LIGHT0, GL_POSITION, pos);

			//,ģͱ
			glActiveTexture(GL_TEXTURE0);
			glBindTexture(GL_TEXTURE_2D, planeTexture);
			//,APIԶɵ
			glActiveTexture(GL_TEXTURE1);
			glBindTexture(GL_TEXTURE_2D, shadowTexture);

			auto svM = Matrix4::setCamera(lightpos.x, lightpos.y, lightpos.z, 0.f, 0.f, 0.f);
			auto spM = Matrix4::setFrustum(90.0f, shadowWidth / shadowHeight, 1.0f, 1000.0f);
			auto eye = mcamera->getEye();
			auto target = mcamera->getTarget();
			auto vM = Matrix4::setCamera(eye.x, eye.y, eye.z, target.x, target.y, target.z);
			auto pM = Matrix4::setFrustum(45.0f, (GLfloat)this->widht / (GLfloat)this->height, 0.1f, 100.0f);
			Matrix4 mM;
			mM.translate(mplane->position.x, mplane->position.y, mplane->position.z);

			program.enable();
			program.setUniformMatrix("shadowViewMat", svM.get());
			program.setUniformMatrix("shadowProMat", spM.get());
			program.setUniformMatrix("nm", mM.get());
			program.setUniformMatrix("nv", vM.get());
			program.setUniformMatrix("np", pM.get());
			program.setUniform("normal", 0.f, 1.f, 0.f);
			program.setUniform("texture2D", 0);
			program.setUniform("uShadowMap", 1);
			mplane->drawShader(0, 1);
			program.disable();
			//ǵĹص,ȻӰģ
			glActiveTexture(GL_TEXTURE0);
			glBindTexture(GL_TEXTURE_2D, 0);
			glActiveTexture(GL_TEXTURE1);
			glBindTexture(GL_TEXTURE_2D, 0);

			//,,
			sphLight->position.x = lightpos.x;
			sphLight->position.y = lightpos.y;
			sphLight->position.z = lightpos.z;
			this->drawModel(false);
			glutSwapBuffers();
		}

		void drawModel(bool shadow)
		{
			sphLight->draw();
			msphere->draw();

			glPushMatrix();
			glTranslatef(0, 0.3f, 0);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::blue);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::green);
			//glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material::white);
			glutSolidTeapot(1);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(-3, 0, 1);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::green);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::white);
			glutSolidCube(1);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(3, 0, -1);
			glRotatef(90, -1, 0, 0);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::red);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::white);
			glutSolidCone(1, 2, 20, 20);
			glPopMatrix();
		}

		~programshadowmapping()
		{
			delete sphLight;
			delete mplane;
			delete msphere;
		}
	private:
		sphere* sphLight = nullptr;
		plane* mplane = nullptr;
		sphere* msphere = nullptr;
		glslProgram program;
		int shadowWidth;
		int shadowHeight;
		GLuint sphereTexture = 0;
		GLuint shadowTexture = 0;
		GLuint planeTexture = 0;
		GLuint frameBuffer = 0;
	};
}