#include "glshow.h"
#include "glslprogram.h"
#include "Matrices.h"
#include "Vectors.h"

namespace OpenglTest
{
	class shadowvolumezpass : public glshow
	{
	public:
		shadowvolumezpass()
		{
			tri1[0] = Vector3(1, 3, 1);
			tri1[1] = Vector3(1, 3, 3);
			tri1[2] = Vector3(3, 3, 0);

			tri2[0] = Vector3(1, 2, -1);
			tri2[1] = Vector3(-1, 2, -1);
			tri2[2] = Vector3(1, 2, 1);

			mplane = new plane(201, 201, 0.1, 0.1, 0.f);
			sphLight = new sphere(16, 16, 0.1f);
		}

		void createScene()
		{
			glshow::createScene();
			glEnable(GL_LIGHTING);
			glEnable(GL_LIGHT0);
			glEnable(GL_DEPTH_TEST);

			glLightfv(GL_LIGHT0, GL_DIFFUSE, material::white);
			glLightfv(GL_LIGHT0, GL_SPECULAR, material::white);
			//ƹ
			sphLight->mat->face = GL_FRONT_AND_BACK;
			material::setValue(sphLight->mat->emission, material::white);
			//
			mplane->mat->face = GL_FRONT_AND_BACK;
			//СʱҪӰ
			material::setValue(mplane->mat->ambinet, material::blue);
			//մʱҪӰ
			material::setValue(mplane->mat->diffuse, material::white);
			material::setValue(mplane->mat->specular, material::red);
			//mplane->position = vector3(0.f, 1.f, 0.f);
		}

		void draw()
		{
			if (widht <= 0 || height <= 0)
				return;
			auto timeLenght = clock();
			lightpos.x = cos(timeLenght / 1000.0f) * 2.0f;
			lightpos.y = 5.0f;
			lightpos.z = sin(timeLenght / 1000.0f) * 2.0f + 3;
			//һԴ.
			float pos[4] = { lightpos.x, lightpos.y, lightpos.z, 1.0 };
			glLightfv(GL_LIGHT0, GL_POSITION, pos);

			//һPASS д
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
			glClearStencil(0);
			glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
			//Ȼд
			glDepthMask(GL_TRUE);
			glDisable(GL_STENCIL_TEST);
			this->mcamera->lookat();
			sphLight->position.x = lightpos.x;
			sphLight->position.y = lightpos.y;
			sphLight->position.z = lightpos.z;
			sphLight->draw();
			glNormal3f(0, 1, 0);
			mplane->draw();
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::blue);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::green);
			drawTri(tri1);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material::green);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material::blue);
			drawTri(tri2);

			//ڶpass	
			glPushAttrib(GL_ALL_ATTRIB_BITS);
			glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
			glDisable(GL_LIGHT0);
			//glStencilOpSeparate Ҫرü
			glDisable(GL_CULL_FACE);
			//ȿдر Ḳû ע:Ȳһֱ򿪵
			glEnable(GL_DEPTH_TEST);			
			glDepthMask(GL_FALSE);
			glDepthFunc(GL_LESS);
			//ģ
			glEnable(GL_STENCIL_TEST);
			//ģȽϺ
			glStencilFunc(GL_ALWAYS, 0, 0xFF);
			glClearStencil(0);
			// p1: p2:ģûͨ p3:ģͨ,Ȳûͨ p4:Ȳͨ
			glStencilOpSeparate(GL_FRONT, GL_KEEP, GL_KEEP, GL_INCR_WRAP);
			glStencilOpSeparate(GL_BACK, GL_KEEP, GL_KEEP, GL_DECR_WRAP);
			//mplane->draw();
			drawTriVolume(tri1);
			drawTriVolume(tri2);
			//ȡģֵ
			//vector<unsigned char> data;
			//data.resize(widht*height);
			//glReadPixels(0, 0, widht, height, GL_STENCIL_INDEX, GL_UNSIGNED_BYTE, data.data());
			//int index = 0;
			//for_each(data.begin(), data.end(), [&index](unsigned char x){
			//	if (x != 0)
			//	{					
			//		index++;
			//	}
			//});
			//cout << index << endl;

			//pass Ӱ,ȫĻɰֵΪ0ĵطӰ
			glEnable(GL_STENCIL_TEST);
			glStencilFunc(GL_NOTEQUAL, 0, 0xFF);
			glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
			//2.ɫ棬Ӱ
			glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
			//3.ϣӰɫӰıɫһ
			glEnable(GL_BLEND);
			//glBlendFunc(GL_ONE, GL_ONE);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			//4.ȫӰ ģʱ,ֻǰӰĵطű
			glMatrixMode(GL_PROJECTION);
			glPushMatrix();
			glLoadIdentity();
			glOrtho(0, widht, 0, height, -1, 1);
			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
			glLoadIdentity();
			//ȫɫ ģʱ,ֻǰӰĵطű			
			glMaterialfv(GL_FRONT, GL_AMBIENT, material::gray);
			glRectf(0.0, 0.0, widht, height);
			glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
			glMatrixMode(GL_PROJECTION);
			glPopMatrix();
			glMatrixMode(GL_MODELVIEW);
			glPopMatrix();

			glPopAttrib();
			glutSwapBuffers();
		}

		void drawTri(Vector3* tri)
		{
			glBegin(GL_TRIANGLES);
			auto p1 = tri[1] - tri[0];
			auto p2 = tri[2] - tri[0];
			auto normal = p1.cross(p2).normalize();
			glColor3f(1, 1, 1);
			glNormal3f(normal.x, normal.y, normal.z);
			for (int i = 0; i < 3; ++i)
				glVertex3fv(&tri[i][0]);
			glEnd();
		}

		void drawTriVolume(Vector3* tri)
		{
			Vector3 tri_far[3];
			for (int i = 0; i < 3; ++i){
				tri_far[i] = tri[i] + (tri[i] - (lightpos)).normalize() *nfar;
			}
			for (int i = 0; i < 3; ++i){
				glBegin(GL_POLYGON); // ߼extrudeı
				auto p1 = tri_far[i] - tri[i];
				auto p2 = tri[(i + 1) % 3] - tri[i];
				auto normal = p1.cross(p2).normalize();
				glColor3f(i == 0 ? 1 : 0, i == 1 ? 1 : 0, i == 2 ? 1 : 0);
				glNormal3f(normal.x, normal.y, normal.z);
				glVertex3fv(&tri[i][0]);
				glVertex3fv(&tri_far[i][0]);
				glVertex3fv(&tri_far[(i + 1) % 3][0]);
				glVertex3fv(&tri[(i + 1) % 3][0]);
				glEnd();
			}

			// Ͻ
			glBegin(GL_TRIANGLES);
			auto p1 = tri[1] - tri[0];
			auto p2 = tri[2] - tri[0];
			auto normal = p1.cross(p2).normalize();
			glColor3f(1, 1, 1);
			glNormal3f(normal.x, normal.y, normal.z);
			for (int i = 0; i < 3; ++i)
				glVertex3fv(&tri[i][0]);
			glEnd();

			// ׽
			glBegin(GL_TRIANGLES);
			glColor3f(1, 1, 1);
			p1 = tri_far[2] - tri_far[0];
			p2 = tri_far[1] - tri_far[0];
			normal = p1.cross(p2).normalize();
			glNormal3f(normal.x, normal.y, normal.z);
			for (int i = 0; i < 3; ++i)
				glVertex3fv(&tri_far[2 - i][0]);
			glEnd();
		}

		~shadowvolumezpass()
		{
			delete mplane;
			delete sphLight;
		}
	private:
		Vector3 tri1[3];
		Vector3 tri2[3];
		Vector3 lightpos;
		plane* mplane = nullptr;
		sphere* sphLight = nullptr;
		float nfar = 10.0f;
	};
}