#include "sphere.h"
namespace OpenglTest
{
	sphere::sphere(int rign, int seg, float radius)
	{
		rigns = rign;
		segments = seg;
		this->radius = radius;
	}

	void sphere::init()
	{
		vector<float> vectors;
		vector<int> indexs;
		for (int y = 0; y < this->rigns; y++)
		{
			auto phi = float(y) * M_PI / (this->rigns - 1);
			for (int x = 0; x < this->segments; x++)
			{
				auto theta = (float)x*M_PI * 2 / float(segments - 1);
				vectors.push_back(sin(phi)*cos(theta));
				vectors.push_back(cos(phi));
				vectors.push_back(sin(phi)*sin(theta));

				vectors.push_back(radius*sin(phi)*cos(theta));
				vectors.push_back(radius*cos(phi));
				vectors.push_back(radius*sin(phi)*sin(theta));
			}
		}
		for (int y = 0; y < rigns - 1; y++)
		{
			for (int x = 0; x < segments - 1; x++)
			{
				indexs.push_back(y*segments + x);
				indexs.push_back((y + 1)*segments + x);
				indexs.push_back((y + 1)*segments + x + 1);
				indexs.push_back((y + 1)*segments + x + 1);
				indexs.push_back(y*segments + x + 1);
				indexs.push_back(y*segments + x);
			}
		}

		glGenBuffers(1, &vboId);
		glBindBuffer(GL_ARRAY_BUFFER, vboId);
		glBufferData(GL_ARRAY_BUFFER, vectors.size() * 4, vectors.data(), GL_STATIC_DRAW);

		glGenBuffers(1, &eboId);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, eboId);
		glBufferData(GL_ELEMENT_ARRAY_BUFFER, indexs.size() * 4, indexs.data(), GL_STATIC_DRAW);

		indexCount = indexs.size();
		bCreate = true;
	}

	void sphere::draw()
	{
		if (!bCreate)
		{
			this->init();
		}
		mat->draw();

		glPushMatrix();
		glTranslatef(position.x, position.y, position.z);

		glBindBuffer(GL_ARRAY_BUFFER, vboId);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, eboId);

		glInterleavedArrays(GL_N3F_V3F, 0, 0);
		glDrawElements(GL_TRIANGLES, indexCount, GL_UNSIGNED_INT, 0);
		glPopMatrix();
	}

	sphere::~sphere()
	{
	}
}