#include "window.h"
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <stdint.h>

namespace OpenglTest
{
	LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
	{
		switch (uMsg)
		{
		case WM_CLOSE:
		{
						 PostQuitMessage(0);
						 return 0;
		}
		case WM_KEYDOWN:
		{
						   break;
		}
		case WM_KEYUP:
		{
						 break;
		}
		case WM_SIZE:
		{
						//window.resize(LOWORD(lParam), HIWORD(lParam));
						//glwin.resize(LOWORD(lParam), HIWORD(lParam));
						return 0;	// 
		}
		default:
			break;
		}
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}

	Win32Window::Win32Window(string title, int width, int heigth)
	{
		this->title = title;
		this->width = width;
		this->height = heigth;
	}

	bool Win32Window::init(WNDPROC wndProc)
	{
		HGLRC		hRC = NULL;		// OpenGLȾ

		GLuint		PixelFormat;			// ƥĽ
		WNDCLASS	wc;						// ṹ
		DWORD		dwExStyle;				// չڷ
		DWORD		dwStyle;				// ڷ
		RECT		WindowRect;				// ȡþεϽǺ½ǵֵ
		WindowRect.left = (long)0;			// Left   Ϊ 0
		WindowRect.right = (long)width;		// Right  ΪҪĿ
		WindowRect.top = (long)0;				// Top    Ϊ 0
		WindowRect.bottom = (long)height;		// Bottom ΪҪĸ߶

		//fullscreen = fullscreenflag;			// ȫȫ־

		hInstance = GetModuleHandle(NULL);				// ȡǴڵʵ
		wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// ƶʱػΪȡDC
		wc.lpfnWndProc = wndProc;					// WndProcϢ
		wc.cbClsExtra = 0;									// ޶ⴰ
		wc.cbWndExtra = 0;									// ޶ⴰ
		wc.hInstance = hInstance;							// ʵ
		wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);			// װȱʡͼ
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);			// װָ
		wc.hbrBackground = NULL;									// GLҪ
		wc.lpszMenuName = NULL;									// Ҫ˵
		wc.lpszClassName = "OpenG";								// 趨

		if (!RegisterClass(&wc))									// עᴰ
		{
			MessageBox(NULL, "עᴰʧ", "", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;											// ˳FALSE
		}

		dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// չ
		dwStyle = WS_OVERLAPPEDWINDOW;							// 


		AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// ڴﵽҪĴС

		// 
		if (!(hWnd = CreateWindowEx(dwExStyle,							// չ
			"OpenG",							// 
			title.c_str(),								// ڱ
			dwStyle |							// Ĵ
			WS_CLIPSIBLINGS |					// Ĵ
			WS_CLIPCHILDREN,					// Ĵ
			0, 0,								// λ
			WindowRect.right - WindowRect.left,	// õĴڿ
			WindowRect.bottom - WindowRect.top,	// õĴڸ߶
			NULL,								// ޸
			NULL,								// ޲˵
			hInstance,							// ʵ
			NULL)))								// WM_CREATEκζ
		{
			close();								// ʾ
			MessageBox(NULL, "ڴ", "", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;								//  FALSE
		}

		static	PIXELFORMATDESCRIPTOR pfd =				//pfd ߴϣĶʹõظʽ
		{
			sizeof(PIXELFORMATDESCRIPTOR),				// ʽĴС
			1,											// 汾
			PFD_DRAW_TO_WINDOW |						// ʽִ֧
			PFD_SUPPORT_OPENGL |						// ʽ֧OpenGL
			PFD_DOUBLEBUFFER,							// ֧˫
			PFD_TYPE_RGBA,								//  RGBA ʽ
			32,										// ѡɫ
			0, 0, 0, 0, 0, 0,							// Եɫλ
			0,											// Alpha
			0,											// Shift Bit
			0,											// ۼӻ
			0, 0, 0, 0,									// Ծۼλ
			16,											// 16λ Z- (Ȼ) 
			0,											// ɰ建
			0,											// ޸
			PFD_MAIN_PLANE,								// ͼ
			0,											// ʹص
			0, 0, 0										// Բ
		};

		if (!(hDC = GetDC(hWnd)))							// ȡ豸ô?
		{
			close();								// ʾ
			MessageBox(NULL, "ܴһ豸", "", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;								//  FALSE
		}

		if (!(PixelFormat = ChoosePixelFormat(hDC, &pfd)))	// Windows ҵӦظʽ?
		{
			close();								// ʾ
			MessageBox(NULL, "ܴһƥظʽ", "", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;								//  FALSE
		}

		if (!SetPixelFormat(hDC, PixelFormat, &pfd))		// ܹظʽô?
		{
			close();								// ʾ
			MessageBox(NULL, "ظʽ", "", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;								//  FALSE
		}

		if (!(hRC = wglCreateContext(hDC)))				// ܷȡOpenGLȾ?
		{
			close();								// ʾ
			MessageBox(NULL, "ܴOpenGLȾ", "", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;								//  FALSE
		}

		if (!wglMakeCurrent(hDC, hRC))					// Լɫ
		{
			close();								// ʾ
			MessageBox(NULL, "ܼǰOpenGLȻ", "", MB_OK | MB_ICONEXCLAMATION);
			return FALSE;								//  FALSE
		}

		ShowWindow(hWnd, SW_SHOW);						// ʾ
		SetForegroundWindow(hWnd);						// ȼ
		SetFocus(hWnd);									// ü̵Ľ˴

		return TRUE;

	}

	void Win32Window::close(GLvoid)								// ٴ
	{
		if (hDC && !ReleaseDC(hWnd, hDC))					// ܷͷ DC?
		{
			MessageBox(NULL, "ͷDCʧܡ", "رմ", MB_OK | MB_ICONINFORMATION);
			hDC = NULL;										//  DC Ϊ NULL
		}

		if (hWnd && !DestroyWindow(hWnd))					// ܷٴ?
		{
			MessageBox(NULL, "ͷŴھʧܡ", "رմ", MB_OK | MB_ICONINFORMATION);
			hWnd = NULL;										//  hWnd Ϊ NULL
		}

		if (!UnregisterClass("OpenG", hInstance))			// ܷע?
		{
			MessageBox(NULL, "עࡣ", "رմ", MB_OK | MB_ICONINFORMATION);
			hInstance = NULL;									//  hInstance Ϊ NULL
		}
	}

	void Win32Window::resize(int width, int height)
	{
		this->width = width;
		this->height = height;
	}

	Win32Window::~Win32Window()
	{
	}
}
//Win32Window window = Win32Window("opengl", 640, 480);
//glshow glwin = glshow();
//sphere sph = sphere(16, 16, 4);
//
//int main()
//{
//
//	glwin.initgl();
//	glwin.resize(window.getWidth(), window.getHigth());
//	glewInit();
//	MSG	msg;
//	bool keep = true;
//	while (keep)
//	{
//		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
//		{
//			if (msg.message == WM_QUIT)
//			{
//				keep = false;
//			}
//			else
//			{
//				TranslateMessage(&msg);
//				DispatchMessage(&msg);
//			}
//		}
//		else
//		{
//			glwin.draw();
//			sph.draw();
//			SwapBuffers(window.getDC());
//		}
//	}
//	window.close();
//	//test37();
//	_CrtDumpMemoryLeaks();
//	//cin.get();
//	return 0;
//}
